package com.glxp.udidl.admin.service.udplat.impl;

import com.glxp.udidl.admin.dao.udplat.UdplatGoodsMapper;
import com.glxp.udidl.admin.dto.udplat.DeliveryGoods;
import com.glxp.udidl.admin.dto.udplat.HospitalGoods;
import com.glxp.udidl.admin.entity.udplat.UdplatGoods;
import com.glxp.udidl.admin.service.udplat.UdplatGoodsService;
import com.glxp.udidl.admin.util.BeanUtils;
import com.glxp.udidl.common.res.BaseResponse;
import com.glxp.udidl.common.util.ExcelUtil;
import com.glxp.udidl.common.util.ResultVOUtils;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.InputStream;
import java.util.List;

@Service
@Slf4j
public class UdplatGoodsServiceImpl implements UdplatGoodsService {
    @Autowired
    private UdplatGoodsMapper udplatGoodsMapper;
    @Override
    public BaseResponse importExcel(InputStream is, int type) {
        List<UdplatGoods> list;
        try{
            if(type == 1) {
                List<HospitalGoods> list1 = getData1(is);
                list = BeanUtils.convertList2List(list1,UdplatGoods.class);
            }else
            if(type == 2){
                List<DeliveryGoods> list2 = getData2(is);
                //log.info(JSONUtil.toJsonStr(list2));
                list = BeanUtils.convertList2List(list2,UdplatGoods.class);
            }else
                return  ResultVOUtils.error(-1,"文件类型不匹配！");
            return save(list);
        }catch (Exception e){
            return ResultVOUtils.error(-1,"转换格式出错:"+e.getMessage());
        }

        //return ResultVOUtils.success();
    }
    private List<HospitalGoods> getData1(InputStream is) throws Exception{
        ExcelUtil<HospitalGoods> util = new ExcelUtil(HospitalGoods.class);
        return util.importExcel(is);
    }
    private List<DeliveryGoods> getData2(InputStream is) throws Exception{
        ExcelUtil<DeliveryGoods> util = new ExcelUtil(DeliveryGoods.class);
        return util.importExcel(is);
    }
    private BaseResponse save(List<UdplatGoods> list){
        if(list == null || list.size()<1)
            return ResultVOUtils.error(-1,"无数据！");
        //log.info("数据："+JSONUtil.toJsonStr(list));
        int count=0;
        for(UdplatGoods item:list){
            String goodId = item.getDeliveryGoodId();
            if(goodId == null || goodId.isEmpty())
                continue;
            UdplatGoods goods = udplatGoodsMapper.selectByGoodId(goodId);
            if(goods != null)
            {
               BeanUtils.copyProperties(item,goods);
               udplatGoodsMapper.update(goods);
            }else
                item.setUuid(BeanUtils.getUUId());
                udplatGoodsMapper.insert(item);
            count++;
        }
        return ResultVOUtils.success(count);
    }
}
